# Class AbstractSet<E>

java.lang.Object
java.util.AbstractCollection<E>
java.util.AbstractSet<E>

Type Parameters:
  `E` - the type of elements maintained by this set

All Implemented Interfaces:
  `Iterable<E>, Collection<E>, Set<E>`

Direct Known Subclasses:
  `ConcurrentSkipListSet, CopyOnWriteArraySet, EnumSet, HashSet, TreeSet`

public abstract class AbstractSet<E> extends AbstractCollection<E> implements Set<E>
This class provides a skeletal implementation of the `Set` interface to minimize the effort required to implement this interface.

The process of implementing a set by extending this class is identical to that of implementing a Collection by extending AbstractCollection, except that all of the methods and constructors in subclasses of this class must obey the additional constraints imposed by the `Set` interface (for instance, the add method must not permit addition of multiple instances of an object to a set).

Note that this class does not override any of the implementations from the `AbstractCollection` class. It merely adds implementations for `equals` and `hashCode`.

This class is a member of the Java Collections Framework.

Since:
  1.2
See Also:
  - `Collection`
  - `AbstractCollection`
  - `Set`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AbstractSet()`
Sole constructor.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object o)`
Compares the specified object with this set for equality.
`int`
`hashCode()`
Returns the hash code value for this set.
`boolean`
`removeAll(Collection<?> c)`
Removes from this set all of its elements that are contained in the specified collection (optional operation).

### Methods declared in class AbstractCollection

`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, retainAll, toArray, toArray, toString`
Modifier and Type
Method
Description
`boolean`
`add(E e)`
Ensures that this collection contains the specified element (optional operation).
`boolean`
`addAll(Collection<? extends E> c)`
Adds all of the elements in the specified collection to this collection (optional operation).
`void`
`clear()`
Removes all of the elements from this collection (optional operation).
`boolean`
`contains(Object o)`
Returns `true` if this collection contains the specified element.
`boolean`
`containsAll(Collection<?> c)`
Returns `true` if this collection contains all of the elements in the specified collection.
`boolean`
`isEmpty()`
Returns `true` if this collection contains no elements.
`abstract Iterator<E>`
`iterator()`
Returns an iterator over the elements contained in this collection.
`boolean`
`remove(Object o)`
Removes a single instance of the specified element from this collection, if it is present (optional operation).
`boolean`
`retainAll(Collection<?> c)`
Retains only the elements in this collection that are contained in the specified collection (optional operation).
`Object[]`
`toArray()`
Returns an array containing all of the elements in this collection.
`<T> T[]`
`toArray(T[] a)`
Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.
`String`
`toString()`
Returns a string representation of this collection.

### Methods declared in class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

### Methods declared in interface Collection

`parallelStream, removeIf, stream, toArray`
Modifier and Type
Method
Description
`default Stream<E>`
`parallelStream()`
Returns a possibly parallel `Stream` with this collection as its source.
`default boolean`
`removeIf(Predicate<? super E> filter)`
Removes all of the elements of this collection that satisfy the given predicate (optional operation).
`default Stream<E>`
`stream()`
Returns a sequential `Stream` with this collection as its source.
`default <T> T[]`
`toArray(IntFunction<T[]> generator)`
Returns an array containing all of the elements in this collection, using the provided `generator` function to allocate the returned array.

### Methods declared in interface Iterable

`forEach`
Modifier and Type
Method
Description
`default void`
`forEach(Consumer<? super E> action)`
Performs the given action for each element of the `Iterable` until all elements have been processed or the action throws an exception.

### Methods declared in interface Set

`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, retainAll, size, spliterator, toArray, toArray`
Modifier and Type
Method
Description
`boolean`
`add(E e)`
Adds the specified element to this set if it is not already present (optional operation).
`boolean`
`addAll(Collection<? extends E> c)`
Adds all of the elements in the specified collection to this set if they're not already present (optional operation).
`void`
`clear()`
Removes all of the elements from this set (optional operation).
`boolean`
`contains(Object o)`
Returns `true` if this set contains the specified element.
`boolean`
`containsAll(Collection<?> c)`
Returns `true` if this set contains all of the elements of the specified collection.
`boolean`
`isEmpty()`
Returns `true` if this set contains no elements.
`Iterator<E>`
`iterator()`
Returns an iterator over the elements in this set.
`boolean`
`remove(Object o)`
Removes the specified element from this set if it is present (optional operation).
`boolean`
`retainAll(Collection<?> c)`
Retains only the elements in this set that are contained in the specified collection (optional operation).
`int`
`size()`
Returns the number of elements in this set (its cardinality).
`default Spliterator<E>`
`spliterator()`
Creates a `Spliterator` over the elements in this set.
`Object[]`
`toArray()`
Returns an array containing all of the elements in this set.
`<T> T[]`
`toArray(T[] a)`
Returns an array containing all of the elements in this set; the runtime type of the returned array is that of the specified array.

## Constructor Details

### AbstractSet

protected AbstractSet()
Sole constructor. (For invocation by subclass constructors, typically implicit.)

## Method Details

### equals

public boolean equals(Object o)
Compares the specified object with this set for equality. Returns `true` if the given object is also a set, the two sets have the same size, and every member of the given set is contained in this set. This ensures that the `equals` method works properly across different implementations of the `Set` interface.

This implementation first checks if the specified object is this set; if so it returns `true`. Then, it checks if the specified object is a set whose size is identical to the size of this set; if not, it returns false. If so, it returns `containsAll((Collection) o)`.

Specified by:
  `equals` in interface `Collection<E>`
Specified by:
  `equals` in interface `Set<E>`
Overrides:
  `equals` in class `Object`
Parameters:
  `o` - object to be compared for equality with this set
Returns:
  `true` if the specified object is equal to this set
See Also:
  - `Object.equals(Object)`
  - `Set.equals(Object)`
  - `List.equals(Object)`

### hashCode

public int hashCode()
Returns the hash code value for this set. The hash code of a set is defined to be the sum of the hash codes of the elements in the set, where the hash code of a `null` element is defined to be zero. This ensures that `s1.equals(s2)` implies that `s1.hashCode()==s2.hashCode()` for any two sets `s1` and `s2`, as required by the general contract of `Object.hashCode()`.

This implementation iterates over the set, calling the `hashCode` method on each element in the set, and adding up the results.

Specified by:
  `hashCode` in interface `Collection<E>`
Specified by:
  `hashCode` in interface `Set<E>`
Overrides:
  `hashCode` in class `Object`
Returns:
  the hash code value for this set
See Also:
  - `Object.equals(Object)`
  - `Set.equals(Object)`

### removeAll

public boolean removeAll(Collection<?> c)
Removes from this set all of its elements that are contained in the specified collection (optional operation). If the specified collection is also a set, this operation effectively modifies this set so that its value is the asymmetric set difference of the two sets.

This implementation determines which is the smaller of this set and the specified collection, by invoking the `size` method on each. If this set has fewer elements, then the implementation iterates over this set, checking each element returned by the iterator in turn to see if it is contained in the specified collection. If it is so contained, it is removed from this set with the iterator's `remove` method. If the specified collection has fewer elements, then the implementation iterates over the specified collection, removing from this set each element returned by the iterator, using this set's `remove` method.

Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by the `iterator` method does not implement the `remove` method.

Specified by:
  `removeAll` in interface `Collection<E>`
Specified by:
  `removeAll` in interface `Set<E>`
Overrides:
  `removeAll` in class `AbstractCollection<E>`
Parameters:
  `c` - collection containing elements to be removed from this set
Returns:
  `true` if this set changed as a result of the call
Throws:
  `UnsupportedOperationException` - if the `removeAll` operation is not supported by this set
  `ClassCastException` - if the class of an element of this set is incompatible with the specified collection (optional)
  `NullPointerException` - if this set contains a null element and the specified collection does not permit null elements (optional), or if the specified collection is null
See Also:
  - `AbstractCollection.remove(Object)`
  - `AbstractCollection.contains(Object)`